/*********************************************************
Program Name: 	DColor
Coder:         Jeremy C. Witt
Email:			wittj@onramp.net
Web:				http://www.cryptnet1.net
Date:				March 1999
Module Name:	dc.c    (16 Bit Target)
Desc:				This program is a HotDirectory Clone
					(directory Lister/Color Coder for Dos)
**********************************************************/
#include "dc.h"

/************************************************/
/*PROCEDURE MAIN: This is the Main Jobby        */
/************************************************/
int main(int argc, char *argv[])
{
   int i,j;				/*standard iterator*/
   int EndOfData;    /*Specifies there's no more data to output*/
   int Filetype;     /*Used to hold the color value*/
   int finish;       /*Sentinal to finish processing MOD 4*/
   char key;  			/*if Key=q on pagebreak then quit*/
   char ltemp[5];

   /*Initialize Local Data*/
   ParamData.qualif[0]=0;           /*Init Qualifier*/
   ParamData.BreakonPages = 1;      /*Break on pages*/
   ParamData.LinestoDisplay=80;     /*Display 25 lines*/
   ParamData.SortType      =0;		/*Unsorted*/
   ParamData.UpDown        =0;		/*LeftRight Display*/
   EndOfData =0;
   iterator  =FirstDataPtr;
   FilesMo   =0;

   /*Parse command Line options*/
   for (i=1; i<argc; i++)
   {
   	if (argv[i][0] == '/')
      {
      	/*do more parsing*/
         switch (argv[i][1])
         {
         	case 'h':
            case '?':
            case 'H':
            	ShowHelp();
               return 0; /*Exit the Program*/
            case 'l':
            case 'L':
               ParamData.LinestoDisplay=180;
            	break;
            case 'p':
            case 'P':
            	ParamData.BreakonPages = 0;
               break;
            case 'f':
            case 'F':
					ParamData.SortType = 1;
               break;
            case 's':
            case 'S':
					ParamData.SortType = 3;
            	break;
            case 'e':
            case 'E':
            	ParamData.SortType = 2;
               break;
            case 'u':
            case 'U':
               ParamData.UpDown = 1;
            	cprintf("IMPLEMENT: UPDOWNMode()\r\n");
               return 0;
               break;
            case 'c':
            case 'C':
            	clrscr();
            	break;
            default:
            	ShowHelp();
               return 0; /*Exit the Program*/
         }
      }
      else
      {
      	strcpy(ParamData.qualif,argv[i]);
      }
   }

   /*Reads files in from Directory and inits variables*/
   initStuff();

   /*Place the Output Header*/
	placeHeader();

   /*Start Main Processing Loop*/
   while (!EndOfData)
   {
   	/*Parse the File Name located in iterator*/
   	Filetype = parseFileName(iterator);

		/*Place the Text on Screen 0 Data means stop*/
   	FilesMo  = placeText(Filetype);
      if (FilesMo==0)
      {
      	/*Print the File Size*/
         printSize();

         /*Set the iterator to the Next File to Output*/
      	//iterator = JData[iterator].NextDataPtr;
         iterator++;

         /*Add Horiz Rule if Necessary*/
         if ((iterator%4)!=0)
         {
            	textcolor(LIGHTCYAN);
			      cprintf(widget0);
         }
         else
          	cprintf(" ");

         /*80 FOR STD DISPLAY (25 LINES 180 FOR MINE)*/
         if ((iterator%ParamData.LinestoDisplay)==0 && ParamData.BreakonPages)
         {
         	cprintf("Press a key to continue (q quits)\r\n");
         	key = getch();
            if (key == 'q')
            {  /*User wants to Bail so do it*/
            	textcolor(LIGHTGRAY);
               cprintf("\r\n");
            	return 0;
            }
         }
      }
      else
      {
      	/*This Finishes out the Table with no files*/
      	finish = 4-((iterator)%4);
         if (finish !=4)
         	finishLine(finish);
      	EndOfData =1;
      }
   }
   if (finish !=4)
   	cprintf("\r\n");

   /*Place the Footer Horiz Rule plus disk info*/
   placeFooter();
	return 0;
}

/*Ok Simple enough Draw the entry Text*/
/**************************************/
void placeHeader()
{
   char path[81];
   textcolor(YELLOW);
   cprintf("JWDir 0.96A                                              by Jeremy C. Witt 1999\n\r");
   getcwd(path,80);
   cprintf(path);
   switch (ParamData.SortType)
	{
      default:
      	cprintf("       SORT:<UNSORTED>");
         break;
   	case 1:
        	cprintf("       SORT:<FILENAME>");
         break;
      case 2:
        	cprintf("       SORT:<EXTENSION>");
         break;
      case 3:
      	cprintf("       SORT:<SIZE>");
         break;
   }
   cprintf("\r\n");
   /*Draw Horizontal Rule*/
   textcolor(LIGHTCYAN);
   cprintf(hrule);
}

/*This Procedure Draws the Exit Text and Horiz Rule*/
/***************************************************/
void placeFooter()
{
   struct 		diskfree_t diskfree;
   unsigned 	currentdrive;
   long 			spaceavail;

   textcolor(LIGHTCYAN);

   /*Set the Little thingys to point up*/
   hrule[19]=193;
   hrule[39]=193;
   hrule[59]=193;

   /*print Horizontal Rule*/
   cprintf(hrule);

   /*Calculate the Free Disk Space on Current Drive*/
   _dos_getdiskfree(0,&diskfree);
   _dos_getdrive(&currentdrive);
   spaceavail = (long)diskfree.bytes_per_sector*
   					(long)diskfree.sectors_per_cluster*
                  (long)diskfree.avail_clusters;

   /*Add Exit Text*/
   textcolor(YELLOW);
   cprintf("       %d", iterator);
   textcolor(LIGHTCYAN);
   cprintf(" files totalling ");
   textcolor(YELLOW);
   cprintf("%ld",totalsize);
   textcolor(LIGHTCYAN);
   cprintf(" bytes, ");
   textcolor(YELLOW);
   cprintf("%ld",spaceavail);
   textcolor(LIGHTCYAN);
   cprintf(" bytes free on Drive ");
   cprintf("%c:\n\r",(currentdrive+64));
   /*Revert to normal Color*/
   textcolor(LIGHTGRAY);
   cprintf("\r\n");
}

/*This procedure Initializes Vars and Loasd FileList
  Additionally if a Sort is Specified it sorts the files
**********************************************************/
void initStuff()
{
	int i;
   struct ffblk ffblk;
   int done;
   /*Make Horiz Rule Thingys point down */
   for (i=0;i<80;i++)
   	hrule[i]=196;
   hrule[19]=194;
   hrule[39]=194;
   hrule[59]=194;
   totalsize=0;

   /*Setup Vertical Rule*/
   widget0[0] = 179;
   widget0[1] = 0;

   /*get Directory Data*/
   i= 0;

   /*Sanity Check on Qualifier*/
   if (ParamData.qualif[0] == 0)
   	sprintf(ParamData.qualif,"*.*");
   done = findfirst(ParamData.qualif,&ffblk,FA_RDONLY|FA_HIDDEN|FA_SYSTEM|FA_LABEL|FA_DIREC|FA_ARCH);
   FirstDataPtr = 0;
   while (!done)
   {
   	if (i > 999)
      {
      	textcolor(LIGHTRED);
      	cprintf("ERROR: DColor only operates on less than 1000 files\r\n");
         exit();
      }
   	memcpy(JData[i].file,ffblk.ff_name,13);
      totalsize = totalsize + ffblk.ff_fsize;
      JData[i].size = ffblk.ff_fsize;
      if (ffblk.ff_attrib == FA_DIREC)
      	JData[i].directory=1;
      else
      	JData[i].directory=0;
      /*Setup the Linked List*/
/*      JData[i].NextDataPtr   = i+1;
      JData[i].PrevDataPtr   = i-1;
*/      
 /*     switch (ParamData.SortType) // WORK ON THIS!
      {
      	case 1:
				InsertByFile(i);
         	break;
         case 2:
         	InsertByExt(i);
         	break;
         case 3:
         	InsertBySize(i);
         	break;
         default:
         	break;
      }
 */
      i++;
   	done = findnext(&ffblk);
   }
   totalfiles = i-1;
   JData[i].file[0]=0;
   //JData[i].NextDataPtr = -1;
	if (ParamData.SortType !=0)
   	SortFiles();
}

/*This is a Generic Text Placer (I wish)*/
/****************************************/
int placeText(int type)
{
 /*Sanity Check if file isn't zero*/
 if (JData[iterator].file[0] != 0 && JData[iterator].file[0] != '.')
 {
 	textcolor(type);
 	cprintf(JData[iterator].file);
 }
 else
 {
 	/*Color and Format Parent Directories Specially*/
 	if (JData[iterator].file[0] == '.')
   {
   	textcolor(LIGHTMAGENTA);
   	if (JData[iterator].file[1]=='.')
   		cprintf("..          ");
      else
      	cprintf(".           ");
   }
   else
 		return 1; /*No More Data Left*/
 }
 return 0;
}

/*This Formats the Filename into DColor */
/*Spec output and Also Returns the Color*/
/*Of the File Based on it's Ext/Type    */
/****************************************/
int parseFileName(int iterator)
{
   int Tcolor;				/*Type/Color*/
   int noExtension;     /*File has Extension?*/
   char holder[13];     /*Temp Data Holder*/
   char extension[4];   /*Temp Extension Holder*/

   /*Init locals*/
   int  index=0;
   int  index2=0;
   noExtension = 0;

   /*Sanity Check for a file existing in iterator OR not rec dir*/
   if (JData[iterator].file[0] == 0 || JData[iterator].file[0]=='.')
   {
    	return 47; /*bogus color value*/
   }

   /*Copy our data to the holder, init other*/
   memcpy(holder,JData[iterator].file,13);
   memset(extension,0,4);
   memset(JData[iterator].file,32,13);

  	/*This is for main part of filename*/
  	while(((holder[index] != 0) && (holder[index] != '.')) && (index < 12))
   {
     	JData[iterator].file[index]=holder[index];
      index++;
   }

   /*Make sure we didn't hit the limit on size*/
   if (index != 12)
   {
   	/*Test for Next Part Extension! or None!*/
   	if (holder[index] ==0)
   	{ /*Pad and Leave We're done here*/
      	noExtension = 1;
   		for (;index<12;index++)
      	{
      		JData[iterator].file[index] = 32;
      	}
   	}
   	else if (holder[index]=='.')
   	{ /*Ok now Fill extension*/
      	index++;
         index2=9; /*This is the position of Ext in String*/
         while ((holder[index] !=0) && (index<12))
         {
         	JData[iterator].file[index2]=holder[index];
            extension[index2-9]   =holder[index];
            index++;
            index2++;
         }
         if (index != 12)
         {
         	/*Pad and Leave*/
            for(;index2<12;index2++)
            {
            	JData[iterator].file[index2]=' ';
               extension[index2-9]=' ';
            }
         }
   	}
   }
   else
   {
   	noExtension = 1;
   }
   JData[iterator].file[12]=0;

   Tcolor=LIGHTGRAY;
   if (JData[iterator].directory == 1)
   	Tcolor = LIGHTMAGENTA;
   else if (noExtension ==0)
   {
   	Tcolor = chooseColor(extension);
   }
	return Tcolor;
}


/*This Puts blanks and Widgets on the rest of the line*/
/*If there is left over space (i.e. files MOD 4 DNE 0)*/
/******************************************************/
void finishLine(int numleft)
{
   int index;
   for(index=0;index<numleft-1;index++)
   {
     	cprintf("                   ");
		textcolor(LIGHTCYAN);
		cprintf(widget0);

   }
   	cprintf("                  ");
}

/*Color Parser Looks at extensions and Picks color*/
/*************************************************/
int chooseColor(char *extension)
{
	int fColor;
   fColor  = LIGHTGRAY;
	switch (extension[0])
   {
   	case 'A':
         	fColor = LIGHTBLUE;
   		break;
	  	case 'B':
         if (extension[1]=='A' && extension[2]=='T')
         	fColor = LIGHTRED;
   		break;
	  	case 'C':
         if (extension[1]=='O' && extension[2]=='M')
        		fColor = LIGHTGREEN;
   		break;
   	case 'D':
         if (extension[1]=='L' && extension[2]=='L')
         	fColor = BROWN;
   		break;
   	case 'E':
         if (extension[1]=='X' && extension[2]=='E')
	        	fColor = LIGHTCYAN;
   		break;
   	case 'L':
         if (extension[1]=='Z' && extension[2]=='H')
         	fColor = LIGHTBLUE;
         else if (extension[1]=='I' && extension[2]=='B')
         	fColor = BROWN;
   		break;
   	case 'T':
         if (extension[1]=='X' && extension[2]=='T')
         	fColor = WHITE;
   		break;
   	case 'Z':
      	if (extension[1]=='I' && extension[2]=='P')
         	fColor = LIGHTBLUE;
   		break;
   	default:
      	fColor = LIGHTGRAY;
   		break;
   }
   return fColor;
}

/*This Function Prints the File Size*/
/************************************/
void printSize ()
{
	char buffer[8];
   int smaller;
   memset(buffer,0,8);

	if (JData[iterator].directory == 0)
   {
   	if (JData[iterator].size <= 999999)
   		sprintf(buffer,"%7ld",JData[iterator].size);
      else
      {
      	smaller = JData[iterator].size/1048576;
         sprintf(buffer,"%3d MEG",smaller);
      }
   	textcolor(YELLOW);
   	cprintf(buffer);
   }
   else
   	cprintf("  <DIR>");
}

/*The Help Text*/
/***************/
void ShowHelp()
{
	textcolor(LIGHTGREEN);
	cprintf("DColor: Version 0.96A    Jeremy C. Witt (www.cryptnet1.net)\r\n");
   textcolor(YELLOW);
   cprintf("***********************************************************\r\n");
   textcolor(LIGHTCYAN);
 	cprintf("USAGE:");
   textcolor(LIGHTMAGENTA);
   cprintf("   dc <filespc> [/[H|U|L|C|P|F|S|E]\r\n");
   textcolor(LIGHTCYAN);
   cprintf("OPTIONS: \r\n");
   textcolor(LIGHTMAGENTA);
   cprintf("/H This help Text\r\n");
   cprintf("/F SORT by File Name\r\n");
   cprintf("/E SORT by Extension\r\n");
   cprintf("/S SORT by File Size\r\n");
   cprintf("/U Toggle UpDown Column Display\r\n");
   cprintf("/P Toggle Continuous Output (Pause Mode OFF)\r\n");
   cprintf("/C Toggle Clear Screen First\r\n");
   cprintf("/L 50 Line display (25 is Default)\r\n");
   textcolor(LIGHTCYAN);
   cprintf("NOTE:\r\n");
   textcolor(LIGHTGREEN);
   cprintf("This Program is Freeware.. I take no responsbility when it \r\n");
   cprintf("reformats your HardDrive and eats your pizza.\r\n");
   cprintf("Expect the code to be GPL'd as soon as I take out some \r\n");
   cprintf("of the worst hatchet jobs.     `\\u (wittj@onramp.net)\r\n");
   textcolor(YELLOW);
   cprintf("************************************************************\r\n");
   textcolor(LIGHTGRAY);
   cprintf("\r\n");
   return;
}


/*Bah Needless to say I gotta change this... 2n is
  Just not acceptable speed (well on a 1000 files
  I can't tell on my computer... but I'm sure I could
  on a 486 or something*/
/*****************************************************/
void SortFiles()
{
	int i,j;
   char *ext1;
   char *ext2;
   	/*Plain Jane Bubble Sort WooWoo n^2 now that's efficient*/
   	for (i=0;i<totalfiles;i++)
   	{
   		for (j=0;j<totalfiles;j++)
      	{
		   	switch (ParamData.SortType)
            {
   				case 1:
               	/*FileName*/
               	if (strcmp(JData[j+1].file,JData[j].file) < 0)
                  {
                  	// File j+1 is smaller swap
                     SortHolder = JData[j+1];
                     JData[j+1] = JData[j];
                     JData[j]   = SortHolder;
                  }
               	break;
               case 2:
               	/*Extension*/
                  ext2 = strchr(JData[j+1].file,'.');
                  ext1 = strchr(JData[j].file,'.');
                  if (strcmp(ext2,ext1) < 0)
                  {
                  	// File j+1 is smaller swap
                     SortHolder = JData[j+1];
                     JData[j+1] = JData[j];
                     JData[j]   = SortHolder;
                  }
               	break;
               case 3:
               	/*FileSize*/
                  if (JData[j+1].size < JData[j].size)
                  {
                  	// File j+1 is smaller swap
                     SortHolder = JData[j+1];
                     JData[j+1] = JData[j];
                     JData[j]   = SortHolder;
                  }
               	break;
            }
      	}
   	}
}

/*Sort By File Name Inserts this into the linked List*/
/************************************************/
//void InsertByFile(int position)
//{
//	int index;
//}

/*Sort By File Extension Inserts this into the linked List*/
/************************************************/
//void InsertByExt(int position)
//{
//	int index;
//}

/*Sort By File Size Inserts this into the linked List*/
/************************************************/
//void InsertBySize(int position)
//{
//	int index;
//}

